// KhMatrix $B7?$N%G!<%?$N$?$a$N4X?t(B

#if !defined(khmatrixfunc_cc)
#define khmatrixfunc_cc

#include <stdio.h>

//#include "/home/sayama/ohymos-lib/ohymos-3.0f/htmls/data2str.h"
#include "data2str.h"
#include "khmatrix.h"

// Data::Dstr2dpack $B$+$i8F$P$l$k(B (p_tmp.cc)
template <class T>
void dstr2data(char*& dstr, KhMatrix<T>& a)
{
// 	int wRow, wCol;
 	int wGx, wGy;
 	dstr2data(dstr, wGx);
 	dstr2data(dstr, wGy);
 	a.Resize(wGx, wGy);
 	for (int j = 0; j < wGy; j++)
	{
		for (int i = 0; i < wGx; i++)
		{
			dstr2data(dstr, a.Ref(i, j));
		}
	}
}

// Data::Dpack2file $B$+$i8F$P$l$k(B (p_tmp.cc)
template <class T>
void data2file(KhMatrix<T>& a, FILE* fp)
{
	int wGx = a.GetRows();
	int wGy = a.GetCols();
	data2file((int)wGx, fp);
	data2file((int)wGy, fp);
	for (int j = 0; j < wGy; j++)
	{
		for (int i = 0; i < wGx; i++)
		{
			data2file((T)(a(i, j)), fp);
		}
	}
}

// Data::Dpack2ofile $B$+$i8F$P$l$k(B (p_tmp.cc)
template <class T>
void data2ofile(KhMatrix<T>& a, FILE* fo)
{
	int wGx = a.GetRows();
	int wGy = a.GetCols();

 	data2ofile((int)wGx, fo);
	fputc(' ', fo);
 	data2ofile((int)wGy, fo);

// 	// for debugging
// 	fputc(' ', fo);

 	for (int j = 0; j < wGy; j++)
	{
		fputc('\n', fo);
		for (int i = 0; i < wGx; i++)
		{
			data2ofile((T)(a(i, j)), fo);
			fputc(' ', fo); 
		}
	}
}

#endif

/*; end of file */
