// ksedgefc2devp-1.cc, ksedgefc2devp-1.h
// Sun Sept 05 2004
// ήήѴطھѤ᡼򡢿幩ʸ˰¡˰ή
// ƳήήѴطγȯ, 48, 2004, Ωë
// ǼΤѹץ༫ȤȤϱëʸǻѤΤƱ

// Oct. 28, 2005
// ksedgefc2d-1.h -> ksedgefc2d.h ѹ
// ȯ̤Ϥƥåھʬ̤˱Ƽ¾ȯ̤׻롥
// ׻ˡH13.߷νƱ

// Jun. 20, 2006
// Save_terminal_state  Set_initial_state ѹ
// ޤǤϷ׻λ˳ƥåξ岼ήüή̤Ϥ
// ޤƽͤȤƤޤˤ礭
//ʤȤˡ˷׻ˤȤȽΤǡ
// ׻λ˳ƥåƥΡɤή̤Ϥ褦ˤ
// ̤ξбǤ褦ѹ
// ɤꥨåξ岼ήüΤή̤ͿȤϡ[Data Format Name]
//  KsEdgeFc Initial State Format ȤƥΡɤͿ
//  KsEdgeFc Initial All State Format Ȥ롣

// Jul. 31, 2007
// ksedgefc2devp-1.cc: ksedgefc2d-1.3.1 Ȥ˾ȯ׻εǽɲá
/* 
[]
Jan. 22, 2008 Ω
962 ն  fclose(fpParam); ɲäclose Ƥʤˡʬή
Ŀ1000Ķȼ¹Ի顼Ǥ
*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>
#include <fstream>

#include "ksedgefc2devp-1.h"	// defines class Edge, KsEdgeFc2d
#include "dfopen.h"	// defines function dataFileOpen

ofstream all_rain_file("all_rain.dat",ios::out); // added for Tracer
//ofstream all_qr_file("all_qr.dat",ios::out);

Boolean Edge::RegisterUpperEdge // p  upperEdgeArray Ͽ
(
 Edge* p
 )
{
  for (int i = 0; i < numberOfUpperEdges; i++)
    {
      if (upperEdgeArray[i] == NULL)
	{
	  upperEdgeArray[i] = p;
	  return (Boolean)YES;
	}
    }
  
  return (Boolean)NO;
}

void Edge::ParametersInFlowModel
// ήη׻ɬפʥѥ᥿ͤɤ߹
(
 double man,	 // ޥ˥󥰤ٷ (m-s)
 double m,	 // q = alpha * pow(h, m)  m
 double ka, 	 // Ʃ巸 (m/s)
 double d, 	 // ظ (m)
 double da, 	 // A ظ (m)
 double dm,	 // ޥȥåظ (m)
 double beta,    // Ʃ巸
 double theta,   // ֺʬνŤ 
 double cmin, 	 // minimum C = dQ/dA
 double Qlevel,  // (mm/hour)
 double eps,     // (-)
 int ndiv, 	 // ֺʬʬ (-)
 int dt		 // time_step (s)
 )
{
  mMan = man;
  mM = m;
  mKa = ka;
  mD = d;
  mDa = da;
  mDm = dm;
  mBeta = beta;
  mTheta = theta;
  mCmin = cmin;
  mQlevel = Qlevel;
  mEps = eps;
  mN = ndiv;
  mDt = dt;

  mQc = new double[mN+1];
  mQn = new double[mN+1];
  
  if (mAtr == 1)
    {
      mAlpha = sqrt(mGrd) / mMan;
      mVa = mKa * mGrd;
      mDx = mL / (double)mN;
    }
  
  mQsmall = mQlevel * mEps * 0.001 / 3600.;
  // mQlevel: ή̤η׻ͤδ (mm/hour). 10.0 ɸ.
  // mEps: ׻ (-). 0.001 ɸ
}


void Edge::TopographicData // åη׻¤٤줿
// edge connection V.2/3/4/5 ե
// ɤ߹
(
 FILE* fpTopo,
 int wTopoDataType
 )
{
  // åֹɤ߹()
  fscanf(fpTopo, "%ld", &mNum);
  assert(mNum > 0);
  
  // åκɸɤ߹(V.2/3)
  // å岼üΥΡֹȤ줾κɸͤɤ߹ߡ
  // åκɸ׻(V.4/5)
  if (wTopoDataType == 2 || wTopoDataType == 3)
    {
      fscanf(fpTopo, "%lf %lf %lf", &mX, &mY, &mZ);
    }
  else if (wTopoDataType == 4 || wTopoDataType == 5)
    {
      long wNum;
      double wUpX, wUpY, wUpZ, wLowX, wLowY, wLowZ;
      fscanf(fpTopo, "%ld %lf %lf %lf %ld %lf %lf %lf", 
	     &wNum, &wUpX, &wUpY, &wUpZ, &wNum, &wLowX, &wLowY, &wLowZ);
      mX = 0.5 * (wUpX + wLowX);
      mY = 0.5 * (wUpY + wLowY);
      mZ = 0.5 * (wUpZ + wLowZ);
    }
  else
    {
      //		mX = mY = mZ = 0.0;
      fprintf(stderr, "E: data format error");
      exit(1);
    }
  
  // ή¦åοɤ߹()
  assert(fscanf(fpTopo, "%d", &numberOfUpperEdges) == 1);
  assert(numberOfUpperEdges >= 0);
  
  // upperEdgeNumArray, upperEdgeArray γ
  if (numberOfUpperEdges > 0) 
    {
      upperEdgeNumArray = new long[numberOfUpperEdges];
      upperEdgeArray = new Edge*[numberOfUpperEdges];
    }
  else	// numberOfUpperEdges == 0
    {
      upperEdgeNumArray = new long;
      upperEdgeArray = new Edge*;
    }
  
  // upperEdgeArray ν
  for (int i = 0; i < numberOfUpperEdges; i++)
    upperEdgeArray[i] = NULL;
  
  // ή¦åֹɤ߹()
  for (int i = 0; i < numberOfUpperEdges; i++)
    {
      long num;
      assert(fscanf(fpTopo, "%ld", &num) == 1);
      upperEdgeNumArray[i] = num;
    }
  
  // ή¦åοɤ߹()
  int tmp;
  assert(fscanf(fpTopo, "%d", &tmp) == 1);
  assert(tmp >= 0);
  
  // ή¦åֹɤ߹()
  
  Boolean outEdgeFromLowerEnd = (Boolean)NO;
  // üήФ륨å YES
  
  for (int i = 0; i < tmp; i++)
    {
      long num;
      assert(fscanf(fpTopo, "%ld", &num) == 1);
      if (num < 0) outEdgeFromLowerEnd = (Boolean)YES;
    }

  // å°ɤ߹()
  
  assert(fscanf(fpTopo, "%d", &tmp) == 1);
  assert(tmp == 1 || tmp == 2);
  mAtr = tmp;
  
  // ήǲüΥåɤǧ
  if (mAtr == 2 && outEdgeFromLowerEnd == (Boolean)NO) // ǲüå
    lowestEdge = (Boolean)YES;
  else 
    lowestEdge = (Boolean)NO;
  
  // mAtr  1 ΤȤ(ή-ήåΤȤ)
  // åĹۡѤɤ߹()
  
  if (mAtr == 1)
    {
      double wlen, wgrd, warea;
      assert(fscanf(fpTopo, "%lf %lf %lf", &wlen, &wgrd, &warea)
	     == 3);
      assert(wlen > 0.0);
      assert(wgrd > 0.0);
      assert(warea > 0.0);
      
      mArea = warea;
      mWidth = mArea / wlen;
      
      // 		printf("wlen : %f\n", wlen);
      // 		printf("wgrd : %f\n", wgrd);
      
      // wlen ϿʿΥʤΤ3ĹѴ
      mL = wlen * sqrt(1.0 + wgrd*wgrd);
      
      // 		printf("mL : %f\n", mL);
      
      // wgrd  tangent ͤʤΤǡsin ͤѴ
      wgrd = atan(wgrd);
      mGrd = sin(wgrd);
      
      // mCos 롣mCos Ϲ߿嶯٤˾褸
      mCos = cos(asin(mGrd));
    }
  
  
  
  // ήʬΨήѤɤ߹(V.3/5)
  if (wTopoDataType == 3 || wTopoDataType == 5)
    {
      
      assert(fscanf(fpTopo, "%lf %lf", &mDist, &mUpperArea) == 2);
      assert(mDist > 0.0);
      assert(mUpperArea >= 0.0);
      
      // // for debugging
      // printf("%ld %f %f\n", mNum, mDist, mUpperArea);
      
      
      
      
    }
  
  // 	// for debugging
  //  	printf("%ld : %d %f %f %f %f %f %d %d\n",
  //  	        mNum, mAtr, mL, mArea, mWidth, mGrd, mCos,
  //  		numberOfUpperEdges, lowestEdge);
}

void Edge::DistributionRate(void)
{
  if (mAtr == 2)	// ή-ƻåξ
    {
      int couter = 1;	// ʬޤ᤿ή¦ʬήåο
      for (int i = 0; i < numberOfUpperEdges; i++)
	{
	  if (upperEdgeNumArray[i] < 0) 
	    // ή¦ʬήå¸ߤ
	    {
	      couter++;
	    }
	}
      
      mDist = 1.0 / couter;
      return ;
    }
  
  // ή-ήåξ
  
  // $mDist = mWidth \sqrt(mGrd) / 
  // 		\sum_{m=1}^{N} mWidth_{m} \sqrt(mGrd_{m})
  
  double tmpa, tmpb;
  tmpa = tmpb = mWidth * sqrt(mGrd);
  
  int counter = 1;				// ή¦ʬήåο
  
  Boolean anyBRedge = (Boolean)NO;
  // ή¦ʬήå˰ĤǤή-ƻå¸ߤ
  // 硢YES 
  
  for (int i = 0; i < numberOfUpperEdges; i++)
    {
      // printf("%ld : %ld\n", mNum, upperEdgeArray[i]->Num());
      
      // ή¦ʬήå¸ߤ
      if (upperEdgeNumArray[i] < 0)
	{
	  counter++;
	  
	  // ʬήåή-ήåǤ
	  if (upperEdgeArray[i]->Atr() == 1)
	    {
	      tmpb += upperEdgeArray[i]->Width() * 
		sqrt(upperEdgeArray[i]->Gradient());
	    }
	  else if (upperEdgeArray[i]->Atr() == 2)
	    {
	      anyBRedge = (Boolean)YES;
	    }
	}
    }
  
  if (anyBRedge == (Boolean)NO)
    {
      mDist = tmpa / tmpb;
    }
  // ή¦ʬήå˰ĤǤή-ƻå¸ߤ
  // ϡμȤʤΤǡñƬǳ 
  else
    mDist = 1.0 / counter;
  
  // 	// for debugging
  // 	printf("%ld %f\n", mNum, mDist);
}

void Edge::CalcUpperArea(void)
{
  // 	if (mAtr == 2)				// ή-ƻåξ
  // 	{
  // 	   mUpperArea = 0.0;
  // 
  // // 	// for debugging
  // // 	printf("%ld %f %f\n", mNum, mDist, mUpperArea);
  // 
  // 	  return ;
  // 	}
  // 
  // 	// ή-ήåξ
  
  // ήή륨å n ĤȤ
  // $mUpperArea = \sum_{i=1}^{n}(mUpperArea_i + mArea_i) \times mDist$
  
  mUpperArea = 0.0;
  for (int i = 0; i < numberOfUpperEdges; i++)
    {
      // printf("%ld : %ld\n", mNum, upperEdgeArray[i]->Num());
      
      // ήή륨å¸ߤ
      if (upperEdgeNumArray[i] > 0)
	{
	  // ήåή-ήåǤ
	  if (upperEdgeArray[i]->Atr() == 1)
	    {
	      mUpperArea += upperEdgeArray[i]->Area() +
		upperEdgeArray[i]->UpperArea();
	    }
	  else if (upperEdgeArray[i]->Atr() == 2)
	    {
	      cerr << "wrong connection of edges:" << endl;
	      cerr << "from " << upperEdgeArray[i]->Num() << " to "
		   << Num() << endl;
	      exit(1);
	    }
	}
    }
  
  mUpperArea *= mDist;
  
  // 	for debugging
  // 	printf("%ld %f %f\n", mNum, mDist, mUpperArea);
}

void Edge::Discharge
(
 double disUpperEnd,	// üǤή
 double disLowerEnd	// üǤή
 )
{
  mQc[0] = mQn[0] = disUpperEnd;
  mQc[mN] = mQn[mN] = disLowerEnd;
  
  // η׻̤ή̤֤ǵ
  for (int i = 1; i <= mN-1; i++)
    {
      mQc[i] = mQn[i] = mQc[0] + 
	(mQc[mN] - mQc[0]) / (double)mN * (double)i ;
    }
}

void Edge::Discharge
(
 double* disUpperEnd,	// üǤή
 double* disLowerEnd	// üǤή
 )
{
  *disUpperEnd = mQc[0];
  *disLowerEnd = mQc[mN];
}

// added by T.Sayama on June 19, 2006
// η׻̤ή̤ꤹ
void Edge::DischargeAllNodeInit
(
 double* disAllNode
)
{
 for (int i = 0; i <= mN; i++)
 {
   mQc[i] = mQn[i] = disAllNode[i];
 }
}

// η׻̤ή̤֤
void Edge::DischargeAllNode
(
 double* disAllNode
)
{
 for (int i = 0; i <= mN; i++)
 {
   disAllNode[i] = mQn[i];
 }
}

void Edge::CalcSatArea
(
 void
 )
{
  // ˰°Ѥη׻
  mSarea = 0.0;
  double wQsat = mVa * mWidth * (mDa - mDm);
  for (int i = 1; i <= mN; i++)
    {
      // ־ü˰
      if (mQn[i-1] >= wQsat)
	{
	  // ֲüǤ˰
	  if (mQn[i] >= wQsat)
	    mSarea += mWidth * mDx;
	  // üǤ˰
	  else
	    mSarea += mWidth * mDx * 
	      (wQsat - mQn[i-1]) / (mQn[i] - mQn[i-1]);
	}
      // üǤ˰
      else
	{
	  // üǤ˰
	  if (mQn[i] >= wQsat)
	    mSarea += mWidth * 
	      (mDx - mDx * (wQsat - mQn[i-1]) / (mQn[i] - mQn[i-1]));
	  // üǤ˰
	  else
	    mSarea += 0.0;
	}
    }
  
  // added by Yutaka ICHIKAWA (Wed Sep  8 11:23:14 1999)
  mSarea *= mCos;
}

void Edge::CalcStorage
(
 void
)
{
  double* wHn = new double[mN+1];
  for (int i = 0; i <= mN; i++)
    {
     if (mWidth == 0.0) // added by T.Sayama on Oct. 10, 2006
     {
      wHn[i] = 0.0;
     }
     else if (mQn[i] < 0.00000001) 
     {
      wHn[i] = 0.0;
     }
     else if (mQn[i]/mWidth < mVa/mBeta * mDm) // ޥȥꥯξ
     {
      wHn[i] = pow((mQn[i]/mWidth)*mBeta/(mDm*mVa),1/mBeta)*mDm;
     }
      else if (mQn[i]/mWidth < mVa/mBeta * mDm + mVa * (mDa - mDm)) // ޥȥꥯήξ
     {
      wHn[i] = mDm + (mQn[i]/mWidth -  mVa/mBeta * mDm) /mVa;   
     }
      else
     {
	  // ͤ h=mDa Ȥ롣
	  double h0 =	
	    mDa + pow(((mQn[i]/mWidth - (mVa*(mDa-mDm) + mVa/mBeta*mDm))/mAlpha),1./mM);
	  double v0 = pow(h0 - mDa, mM - 1.);
	  double q0 = mAlpha*v0*(h0-mDa) + mVa*(h0-mDm) + mVa/mBeta*mDm;
	  double q1;
	  while (1)
	    {
	      h0 = h0 - (q0 - mQn[i]/mWidth)/(mAlpha * mM * v0 + mVa);
	      v0 = pow(h0 - mDa, mM - 1.);
	      q1 = mAlpha*v0*(h0-mDa) + mVa*(h0-mDm) + mVa/mBeta*mDm;
	      // if (q1 > q0 - 0.0000001) break;
	      if (fabs(q1 - q0) < mEps) break;
	      q0 = q1;
	    }
	  wHn[i] = h0;
	  // wHn[i] = h0 + mDm;
	}
  }
  
  mStorage = 0.0;
  mHaverage = 0.0;
  for (int i = 1; i <= mN; i++)
    {
      mStorage += (wHn[i-1]+wHn[i]) * mDx * 0.5 * mWidth;
      // ʿѿ (m)
      mHaverage += (wHn[i-1]+wHn[i]);
    }
  mHaverage /= (double)mN;
  //printf("mStorage : %f\n", mStorage);
  //printf("mHaverage : %f\n", mHaverage);
  delete [] wHn;
}

double Edge::Evalpha  // added by T.Sayama
(
 void
)
{
  // alpha : (¾ȯ / ȯ) η mHaverage ѿȤƷ׻롥
  double alpha;
  double cBeta = 0.3;
  double w = mHaverage / mD;    // Ѵ޿Ψ
  double gammac = mDm / mD;     // ޥȥꥯ˰Ѵ޿Ψ
  double cBetaw;

  // modified by T.Sayama on Jan. 25 from "if(w <= gammac)" to "if(w < gammac)"
  if(w < gammac)
    cBetaw = 0.5 * (1.0 - cos(w/gammac * M_PI));
  else
    cBetaw = 1.0;

  double evagamma = cBetaw * cBeta;
  alpha = 2.0 * pow(evagamma, 0.81) / (1.0 + pow(evagamma, 0.98));

  return alpha;
}

Boolean Edge::Calculate
(
 double r,					// ߿嶯 (mm/hour)
 double e					// ñ̻֤δȯ (mm/hour)
)
{

  // upstream end
  mQn[0] = 0.0;
  for (int i = 0; i < numberOfUpperEdges; i++)
    {
      if (upperEdgeNumArray[i] > 0) // ήå
    {
      mQn[0] += upperEdgeArray[i]->DischargeLowerEnd();
    }
    }
  mQn[0] *= mDist;	// ήʬΨ򤫤
  
  if (mAtr == 2)	// ή-ƻåξ
    {
      mQc[mN] = mQn[0];

      // modified by T.Sayama on June 19, 2006
      for (int i = 1; i <= mN; i++)
      {
        mQn[i] = mQn[0];
      }

      return (Boolean)YES;
    }
  
  double dta = mDt;	// time step (s)
  
  // ȯ̤ˤ뷸׻
  double evalpha = Evalpha();

  mActEvp = evalpha * e;

  // r (mm/h)  ¾ȯ (mm/h)
  r -= mActEvp;

  // lateral inflow
  double rLin = r * 0.001 / 3600.0 * mCos; // ͭ߿嶯 (m/s)
  
  double cold; // double cnew; 
  double inflow_area = mUpperArea;
  
  for (int i = 1; i <= mN; i++)
    {
      double wm = mWidth;
      inflow_area += wm * mDx;
      double delta_q = mQsmall * inflow_area;
      double q = 0.5 * (mQc[i-1] + mQc[i]) / wm;

      cold = PropagationSpeed(mAlpha, mVa, mDa, mDm, mBeta,
             mM, delta_q / wm, q);
      if (cold < mCmin) cold = mCmin;
      
      mQn[i] = (mQc[i] + mTheta * cold * 
        (dta/mDx * mQn[i-1] + dta * wm * rLin) - 
        (1. - mTheta) * cold * dta * 
        ((mQc[i] - mQc[i-1])/mDx - rLin * wm)) / 
        (1. + mTheta * cold * dta / mDx);
      
      if (mQn[i] < 0.)
      {
        //fprintf(stderr, "W: Negative discharge\n");
        //fprintf(stderr, "mQn[i] : %f\n", mQn[i]);
        mQn[i] = 0.;
      }
    }
  
  // ˰°Ѥη׻
  CalcSatArea();
  
  // for debugging
  CalcStorage();
  
  // update state variables
  for (int i = 0; i <= mN; i++)
    {
      mQc[i] = mQn[i];
    }
  
  return (Boolean)YES;
}


double Edge::PropagationSpeed // aQunit б® c ׻֤
(
 double aAlpha, // ѥ᥿ alpha 
 double aVa,	// Ͽή® (m/s)
 double aDa,    // A ظ (m)
 double aDm,	// ޥȥåظ (m)
 double aBeta,	// beta (-)
 double aM,	// kinematic routing parameter (-)
 double aQeps,  // «Ƚ
 double aQunit  // ñή
 )
{ 
  if (aQunit < aVa/aBeta * aDm) //ޥȥꥯξ
    {
      double h = pow(aQunit*aBeta/(aVa*aDm),1/aBeta) * aDm;
      return aVa * pow(h/aDm , aBeta - 1.);
    } 
  else if (aQunit < aVa * (aDa - aDm) + aVa/aBeta * aDm) // ޥȥꥯήξ
    {
      return aVa;
    }
  
  // ɽήȯƤ
  double h0 =
    aDa + pow(((aQunit - (aVa*(aDa-aDm) + aVa/aBeta*aDm))/aAlpha),1./aM);
  double v0 = pow(h0-aDa, aM - 1.);
  double q0 = aAlpha * v0 * (h0-aDa) + aVa * (h0-aDm) + aVa/aBeta * aDm;
  double q1;
  int count;
  count=0;
  while (1)
    {
      h0 = h0 - (q0 - aQunit)/(aAlpha * aM * v0 + aVa);
      v0 = pow(h0 - aDa, aM - 1.);
      q1 = aAlpha*v0*(h0-aDa) + aVa*(h0-aDm) + aVa/aBeta*aDm;
      //      if (q1 > q0 - aQeps) break;
      if (fabs(q1 - q0) < aQeps) break;
      q0 = q1;

      if(count>10000){
        fprintf(stderr, "Warning at PropagationSpeed.\n");
        double c = 0;
        return c;
      }
      count+=1;
    }
  
  double c = aAlpha * aM * v0 + aVa;
  return c;
}

//                                                      //
// --- 鲼 KsEdgeFc2dEvp ˴ؤ implementation --- //
//                                                      //

KsEdgeFc2dEvp::KsEdgeFc2dEvp(char* o_name, int o_num) : Element()
{
  class_name = "KsEdgeFc2dEvp";
  Init(o_name, o_num);
}

Boolean KsEdgeFc2dEvp::Init(char* o_name, int o_num)
{
  // rp,sp ν
  rp.Init("rp", 0);
  evp.Init("evp", 0);
  sp.Init("sp", 0);
  spSarea.Init("spSarea", 0);
  spStorage.Init("spStorage", 0);
  spEvp.Init("spEvp", 0);
  
  mSumRain = 0.0;
  mSumQout = 0.0;
  mStorage = 0.0;
  mSumEvp = 0.0;
  
  return Element::Init(o_name, o_num);
}

KsEdgeFc2dEvp::KsEdgeFc2dEvp(void) : Element()
{
  class_name = "KsEdgeFc2dEvp";
}

void KsEdgeFc2dEvp::Set_parameter(FILE* fp)
{
  int dt;						// time_step (s)
  
  char s1[256], s2[256];		// s1 : edge connection ե
  // s2 : Ʃ巸񤫤줿ե
  
  double xorig, yorig;		// 2߱ǡθɸ (m)
  double dx, dy;				// 2߱ǡζֳִ (m)
  
  if (fscanf(fp, "%d %s %s %lf %lf %lf %lf", 
	     &dt, s1, s2, &xorig, &yorig, &dx, &dy) != 7)
    {
      Eprint(__FILE__, __LINE__);
      // KsEdgeFc2dEvp::Set_parameter
      // can not read parameter file.
      Oprint();
      exit(1);
    }
  
  assert(dt > 0); mDt = dt;
  assert(dx > 0.0); mDx = dx;
  assert(dy > 0.0); mDy = dy;
  
  mXorig = xorig;
  mYorig = yorig;
  
  // åη׻¤٤줿 edge connection V.? ե
  // ɤ߹
  
  FILE* fpTopo;
  assert((fpTopo = dataFileOpen(s1)) != NULL);
  
  // [Data Format Name]: mTopoDataType 
  
  char buf[256];
  while (fgets(buf, 256, fpTopo) != NULL &&
	 strncmp(buf, "[Data Format Name]", 18) != 0) ;
  fgets(buf, 256, fpTopo);
  if (strncmp(buf, "edge connection V.2", 19) == 0)
    {
      mTopoDataType = 2;
    }
  else if (strncmp(buf, "edge connection V.3", 19) == 0)
    {
      mTopoDataType = 3;
    }
  else if (strncmp(buf, "edge connection V.4", 19) == 0)
    {
      mTopoDataType = 4;
    }
  else if (strncmp(buf, "edge connection V.5", 19) == 0)
    {
      mTopoDataType = 5;
    }
  else
    {
      Eprint(__FILE__, __LINE__);
      // KsEdgeFc2dEvp::Set_parameter
      // Invalid topographic data format.
      // Topographic data must be edge connection V.{2/3/4/5} format.
      Oprint();
      exit(1);
    }
  
  while (fgets(buf, 256, fpTopo) != NULL &&
	 strncmp(buf, "[Number of Total Edges]", 23) != 0) ;
  
  long numEdges;				// åο
  fgets(buf, 256, fpTopo);
  assert(sscanf(buf, "%ld", &numEdges) == 1);
  assert(numEdges > 0); numberOfEdges = numEdges;
  assert((edgeArray = new Edge[numberOfEdges]) != NULL);
  
  while (fgets(buf, 256, fpTopo) != NULL &&
	 strncmp(buf, "[Data]", 6) != 0) ;
  
  double totalArea = 0.0;
  for (long i = 0; i < numberOfEdges; i++)
    {
      edgeArray[i].TopographicData(fpTopo, mTopoDataType);
      if (edgeArray[i].Atr() == 1) // ή-ή
	totalArea += edgeArray[i].Area();
    }
  fclose(fpTopo);
  Oprint();
  cout << "\ttotal area: " << totalArea << "(m2)" << endl;
  
  // åֹ򥭡ˤƥХʥĥ꡼Ĥ
  
  for (long i = 0; i < numberOfEdges; i++)
    {
      long num = edgeArray[i].Num();
      treeKeyedByEdgeNumber.Insert(num, &edgeArray[i]);
    }
  
  // ήη׻ɬפʥѥ᥿ͤɤ߹
  
  FILE* fpParam;
  assert((fpParam = dataFileOpen(s2)) != NULL);
  
  // [Data Format Name]
  while (fgets(buf, 256, fpParam) != NULL &&
	 strncmp(buf, "[Data Format Name]", 18) != 0) ;
  fgets(buf, 256, fpParam);
  if (strncmp(buf, "KsEdgeFc Parameter Format", 23) != 0)
    {
      Eprint(__FILE__, __LINE__);
      // KsEdgeFc2dEvp::Set_parameter
      // Invalid data format.
      Oprint();
      exit(1);
    }
  
  // [Number of Total Edges]
  long numtmp;
  while (fgets(buf, 256, fpParam) != NULL &&
	 strncmp(buf, "[Number of Total Edges]", 23) != 0) ;
  fgets(buf, 256, fpParam);
  assert(sscanf(buf, "%ld", &numtmp) == 1);
  if (numtmp != numberOfEdges)
    {
      Eprint(__FILE__, __LINE__);
      // KsEdgeFc2dEvp::Set_parameter
      // Wrong number of total edges given in 
      fprintf(stderr, "%s.\n", s2);
      Oprint();
      exit(1);
    }
  
  // [Data]
  while (fgets(buf, 256, fpParam) != NULL &&
	 strncmp(buf, "[Data]", 6) != 0) ;
  
  long num;	// åֹ
  double man;	// ޥ˥󥰤ٷ (m-s)
  double m;	// q = alpha * pow(h, m)  m
  double ka;	// Ʃ巸 (m/s)
  double d;	// ظ (m)
  double da;	// A ظ (m)
  double dm;	// ޥȥåظ (m)
  double beta;	// Ʃ巸
  double theta;	// ֺʬνŤ (-)
  double cmin;	// minimun C = dQ/dA (m/s)
  double Qlevel;// (mm/hour)
  double eps;	// (-)
  int ndiv;	// ʬ (-)
  
  for (long i = 0; i < numberOfEdges; i++)
    {
      if (fscanf(fpParam, "%ld %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %d",
		 &num, &man, &m, &ka, &d, &da, &dm, &beta, &theta, &cmin,
		 &Qlevel, &eps, &ndiv) != 13)
	{
	  Eprint(__FILE__, __LINE__);
	  // KsEdgeFc2dEvp::Set_parameter
	  // can not read parameter file.
	  fprintf(stderr, "File: %s\n", s2);
	  Oprint();
	  exit(1);
	}
      
      assert(num > 0);
      assert(man > 0.0);
      assert(m > 0.0);
      assert(ka >= 0.0);
      assert(d >= da);
      assert(da >= 0.0);
      assert(0.0 <= dm && dm <= da);
      assert(beta >= 1.0);
      assert(0.0 <= theta && theta <= 1.0);
      assert(cmin > 0.0);
      assert(Qlevel > 0.0);
      assert(eps > 0.0);
      assert(ndiv > 0);
      
      KeyData* pi = treeKeyedByEdgeNumber.GetPtrToData(num);
      if (pi == NULL)
	{
	  Eprint(__FILE__, __LINE__);
	  // KsEdgeFc2dEvp::Set_parameter
	  fprintf(stderr, "Edge %ld was not found in edgeArray\n", num);
	  Oprint();
	  exit(1);
	}
      
      Edge* p = pi->Data();
      p->ParametersInFlowModel(man, m, ka, d, da, dm, beta, theta, cmin,
			       Qlevel, eps, ndiv, dt);
    }

  // upperEdgeArray 
  
  for (long i = 0; i < numberOfEdges; i++)
    {
      int upnum = edgeArray[i].NumberOfUpperEdges();
      for (int j = 0; j < upnum; j++)
	{
	  long num = abs(edgeArray[i].UpperEdgeNumArray(j));
	  KeyData* pi = treeKeyedByEdgeNumber.GetPtrToData(num);
	  if (pi == NULL)
	    {	
	      Eprint(__FILE__, __LINE__);
	      // KsEdgeFc2dEvp::Set_parameter
	      fprintf(stderr, "Edge %ld was not found in edgeArray\n", num);
	      Oprint();
	      exit(1);
	    }
	  
	  Edge* p = pi->Data();
	  assert(edgeArray[i].RegisterUpperEdge(p) == (Boolean)YES);
	}
    }
  
  // ⤷Ϸǡ edge connection V.2 뤤 V.4 ʤС
  // å DistributionRate, CalcUpperArea 
  // edge connection V.3 ⤷ V.5 ʤ mSumArea ׻
  
  mSumArea = 0.0;
  
  if (mTopoDataType == 2 || mTopoDataType == 4)
    {
      for (long i = 0; i < numberOfEdges; i++)
	{
	  edgeArray[i].DistributionRate();
	  edgeArray[i].CalcUpperArea();
	  mSumArea += edgeArray[i].Area();
	}
    }
  else if (mTopoDataType == 3 || mTopoDataType == 5)
    {
      for (long i = 0; i < numberOfEdges; i++)
	{
	  mSumArea += edgeArray[i].Area();
	}
    }
  else 
    {
      Eprint(__FILE__, __LINE__);
      // invalid data format
      Oprint();
      exit(1);
    }
  
  fclose(fpParam);
  // Wed Aug 18 21:18:47 1999
  // rp ǼΤ step Υǡ
  //	rp.Set_data_connection_type(1);
  // 0ʤޤ
  // 1ʤ step
  // 2ʤ pulse
}

void KsEdgeFc2dEvp::Set_initial_state(FILE* fp)
{
  if (fscanf(fp, "%ld %s", &current_time, edgeDisFileName) != 2)
    {
      Eprint(__FILE__, __LINE__);
      // KsEdgeFc2dEvp::Set_initial_state
      // Cannot read initial state file.
      Oprint();
      exit(1);
    }
  
  FILE* fpDis;
  char buf[256];
  assert((fpDis = dataFileOpen(edgeDisFileName)) != NULL);
  int initAllNode;
  
  // [Data Format Name]
  while (fgets(buf, 256, fpDis) != NULL &&
     strncmp(buf, "[Data Format Name]", 18) != 0) ;
  fgets(buf, 256, fpDis);
  if (strncmp(buf, "KsEdgeFc Initial State Format", 27) == 0)
  {
    // ƥåξήüνͤͿ
    initAllNode = 0;
  }
  // added by T.Sayama on June 19, 2006
  else if (strncmp(buf, "KsEdgeFc Initial All State Format", 33) == 0)
  {
    // ƥΡɤνͤͿ
    initAllNode = 1;
  }
  else
  {
    Eprint(__FILE__, __LINE__);
    // KsEdgeFc2dEvp::Set_initial_state
    // Invalid data format.
    Oprint();
    exit(1);
  }

  
  // [Number of Total Edges]
  long numtmp;
  while (fgets(buf, 256, fpDis) != NULL &&
	 strncmp(buf, "[Number of Total Edges]", 23) != 0) ;
  fgets(buf, 256, fpDis);
  assert(sscanf(buf, "%ld", &numtmp) == 1);
  if (numtmp != numberOfEdges)
    {
      Eprint(__FILE__, __LINE__);
      // KsEdgeFc2dEvp::Set_initial_state
      // Wrong number of total edges given in 
      fprintf(stderr, "%s.\n", edgeDisFileName);
      Oprint();
      exit(1);
    }
  
  // [Data]
  while (fgets(buf, 256, fpDis) != NULL &&
	 strncmp(buf, "[Data]", 6) != 0) ;
  
  for (long i = 0; i < numberOfEdges; i++)
    {
      long num;
      double updis, lowdis;
      int wn = edgeArray[i].N();
      double disAll[wn+1];

      if(initAllNode == 0)
      {
        if (fscanf(fpDis, "%ld %lf %lf", &num, &updis, &lowdis) != 3)
        {
          Eprint(__FILE__, __LINE__);
          // KsEdgeFc2d::Set_initial_state
          // can not read discharge file.
          fprintf(stderr, "File: %s\n", edgeDisFileName);
          Oprint();
          exit(1);
        }
        assert(num > 0);
        assert(updis >= 0.0);
        assert(lowdis >= 0.0);
      }

      else
      {
        if (fscanf(fpDis, "%ld", &num) != 1)
        {
          Eprint(__FILE__, __LINE__);
          // KsEdgeFc2dEvp::Set_initial_state
          // can not read discharge file.
          fprintf(stderr, "File: %s\n", edgeDisFileName);
          Oprint();
          exit(1);
        }
        assert(num > 0);

        for (int j = 0; j <= wn; j++)
        {
          if (fscanf(fpDis, "%lf", &disAll[j]) != 1)
          {
            Eprint(__FILE__, __LINE__);
            // KsEdgeFc2dEvp::Set_initial_state
            // can not read discharge file.
            fprintf(stderr, "File: %s\n", edgeDisFileName);
            Oprint();
            exit(1);
          }
          assert(disAll[j] >= 0.0);
        }
      }
      
      KeyData* pi = treeKeyedByEdgeNumber.GetPtrToData(num);
      if (pi == NULL)
      {
        Eprint(__FILE__, __LINE__);
        // KsEdgeFc2dEvp::Set_initial_state
        fprintf(stderr, "Edge %ld was not found in edgeArray\n", num);
        Oprint();
        exit(1);
      }

      Edge* p = pi->Data();
      if(initAllNode == 0)
      {
        p->Discharge(updis, lowdis);
      }
      else
      {
        p->DischargeAllNodeInit(disAll);
      }
      p->CalcSatArea();
      p->CalcStorage(); // added by T.Sayama on Oct. 28, 2005.
    }
  
  fclose(fpDis);
}

void KsEdgeFc2dEvp::Save_terminal_state(FILE* fp)
{
  assert(fp != NULL);
  
  // åξ岼üή̤Ͽե̾
  // 
  // 	char s[256]; char* p = s;
  // 	p = chgex(edgeDisFileName, "tst");
  // 	// chgex ϥեγĥҤѹؿǤ
  // 	// chgex.h Ƥޤ
  
  char s[256];
  strcpy(s, edgeDisFileName);
  strcat(s, ".tst");
  
  // 	fprintf(fp, "%ld %f %s\n", current_time, mRainc, p);
  fprintf(fp, "%ld %s\n", current_time, s);
  
  FILE* fpDis;
  //	fpDis = fopen(p, "w");
  fpDis = fopen(s, "w");
  
  char* commentSection = "[Comment]\nThese are discharge data at both ends of all edges.\nEach column in [Data] section is as follows:\n<edge number>\n<discharge at upper end(m3/s)>\n<discharge at lower end(m3/s)>\n" ;
  //char* dataFormatNameSection = "[Data Format Name]\nKsEdgeFc Initial State Format\n";
  char* dataFormatNameSection = "[Data Format Name]\nKsEdgeFc Initial All State Format\n";
  char* numberOfTotalEdgesSection = "[Number of Total Edges]\n";
  char* dataSection = "[Data]\n";
  
  fprintf(fpDis, "%s", commentSection);
  fprintf(fpDis, "%s", dataFormatNameSection);
  fprintf(fpDis, "%s", numberOfTotalEdgesSection);
  fprintf(fpDis, "%ld\n", numberOfEdges);
  fprintf(fpDis, "%s", dataSection);
  
  for (long i = 0; i < numberOfEdges; i++)
    {
      long num = edgeArray[i].Num();
      double updis, lowdis;
      edgeArray[i].Discharge(&updis, &lowdis);

      //fprintf(fpDis, "%ld %f %f\n", num, updis, lowdis);
      int wn = edgeArray[i].N();
      double disAll[wn+1];
      edgeArray[i].DischargeAllNode(disAll);
      fprintf(fpDis, "%ld", num);
      for (int j = 0; j <= wn; j++)
      {
        fprintf(fpDis, " %f", disAll[j]);
      }
      fprintf(fpDis, "\n");

    }
  
  fclose(fpDis);
}

Boolean KsEdgeFc2dEvp::Initial_output(void)
{
  long CELLBLK = 5;			// 5x5  1 ֥åȤ
  
  // ƼҤɤγʻҥ뤫ǡ뤫Ĵ٤Ƥ
  
  void* fdp; void* ldp;
  if (rp.Get_data_pack(fdp, current_time, ldp) == NO)
    return NO;
  
  // ̥ǡäơԤθĿĴ٤
  time_t wt;
  KhDMatrix wRain;
  
  if (fdp != NULL)
    {
      wt = ((Data<KhDMatrix>*)fdp)->Data_time();
      wRain = ((Data<KhDMatrix>*)fdp)->Value();
    }
  else if (ldp != NULL)
    {
      wt = ((Data<KhDMatrix>*)ldp)->Data_time();
      wRain = ((Data<KhDMatrix>*)ldp)->Value();
    }
  else return NO;
  
  // ٤ο
  long xCellNum = wRain.GetRows(); // x 
  long yCellNum = wRain.GetCols(); // y 
  
  // 	// for debugging
  // 	printf("xCellNum: %ld, yCellNum: %ld\n", xCellNum, yCellNum);
  
  if (xCellNum < CELLBLK || yCellNum < CELLBLK)
    {
      CELLBLK = (xCellNum < yCellNum) ? xCellNum : yCellNum ;
    }
  
  // 	// for debugging
  // 	printf("CELLBLK: %ld\n", CELLBLK);
  
  // 礭ʥ(֥å)ο
  long xBlkNum = (xCellNum%CELLBLK == 0)? 
    xCellNum/CELLBLK : xCellNum/CELLBLK + 1 ;
  long yBlkNum = (yCellNum%CELLBLK == 0)? 
    yCellNum/CELLBLK : yCellNum/CELLBLK + 1 ;
  
  // 	// for debugging
  //  	printf("xBlkNum: %ld, yBlkNum: %ld\n", xBlkNum, yBlkNum);
  
  for (long m = 0; m < numberOfEdges; m++)
    {
      // ή-ήåʳϥå
      if (edgeArray[m].Atr() != 1) continue;
      
      // edgeArray[m] ΰ
      double x = edgeArray[m].X();
      double y = edgeArray[m].Y();
      
      double xl, xu, yl, yu;
      
      // ɤΥ֥åˤ뤫õ
      for (long I = 0; I < xBlkNum; I++)
	{
	  xl = mXorig+(double)I*(double)CELLBLK*mDx;
	  xu = mXorig+(double)(I+1)*(double)CELLBLK*mDx;
	  
	  // 			// for debugging
	  // 			printf("xl: %f, xu: %f\n", xl, xu);
	  
	  for (long J = 0; J < yBlkNum; J++)
	    {
	      yl = mYorig+(double)J*(double)CELLBLK*mDy;
	      yu = mYorig+(double)(J+1)*(double)CELLBLK*mDy;
	      
	      // ȯ
	      if (xl <= x && x < xu && yl <= y && y < yu)
		{
		  // ɤΥˤ뤫õ
		  
		  double wXorig = mXorig + (double)I*(double)CELLBLK*mDx;
		  double wYorig = mYorig + (double)J*(double)CELLBLK*mDy;
		  
		  for (long i = 0; i < CELLBLK; i++)
		    {
		      if (CELLBLK*I + i >= xCellNum)
			{
			  Eprint(__FILE__, __LINE__);
			  // KsEdgeFc2dEvp::Initial_output
			  fprintf(stderr, "Can not find the cell which includes the slope unit %ld,\n", edgeArray[m].Num());
			  fprintf(stderr, "which is located at [%f, %f].\n", x, y);
			  Oprint();
			  exit(1);
			}
		      
		      xl = wXorig+(double)i*mDx;
		      xu = wXorig+(double)(i+1)*mDx;
		      
		      for (long j = 0; j < CELLBLK; j++)
			{
			  // if (CELLBLK*J + j >= yCellNum)
			  // {
			  // 	Eprint(__FILE__, __LINE__);
			  // 	// KsEdgeFc2dEvp::Initial_output
			  // 	// Can not find the cell which includes
			  // 	// the slope unit.
			  // 	fprintf(stderr, "The slope unit is located at [%f, %f].\n", x, y);
			  // 	Oprint();
			  // 	exit(1);
			  // }
			  
			  // ΰüޤ褿ΤǼ x ˿ʤ
			  if (CELLBLK*J + j >= yCellNum)
			    {
			      goto NEXTX;
			    }
			  
			  yl = wYorig+(double)j*mDy;
			  yu = wYorig+(double)(j+1)*mDy;
			  
			  // ȯ
			  if (xl <= x && x < xu && yl <= y && y < yu)
			    {
			      edgeArray[m].Gx(CELLBLK*I + i);
			      edgeArray[m].Gy(CELLBLK*J + j);
			      
			      // // for debugging
			      // printf("edge %ld [%ld, %ld]\n", 
			      //   edgeArray[m].Num(),
			      //   edgeArray[m].Gx(), edgeArray[m].Gy());
			      
			      goto NEXTEDGE;
			    }
			}
		    NEXTX:;
		    }
		}
	    }
	}
      
      // å°륻֥å򸫤Ĥ뤳ȤǤʤä
      Eprint(__FILE__, __LINE__);
      // KsEdgeFc2dEvp::Initial_output
      fprintf(stderr, "    Cannot find the cell block in which\n");
      fprintf(stderr, "    the edge %ld (%f, %f) is included.\n", 
	      edgeArray[m].Num(), edgeArray[m].X(), edgeArray[m].Y());
      Oprint();
      exit(1);
      
      // å°륻ȯ뤳ȤǤΤǡΥåν
      // ˿ʤ
    NEXTEDGE:;
    }

  // ñִ̻ȯ
  KhDMatrix mEvp;
  if (fdp != NULL)
    {
      mEvp = ((Data<KhDMatrix>*)fdp)->Value();
    }
  else if (ldp != NULL)
    {
      mEvp = ((Data<KhDMatrix>*)ldp)->Value();
    }
  else return NO;

  // ׻ϻˤ
  
  mQoutc = 0.0;
  double sarea = 0.0;
  double storage = 0.0;
  double sumevp = 0.0;
  for (long i = 0; i < numberOfEdges; i++)
    {
      if (edgeArray[i].LowestEdge() == (Boolean)YES)
      {
        mQoutc += edgeArray[i].DischargeLowerEnd();
      }

      if (edgeArray[i].Atr() == 1)
      {
        sarea += edgeArray[i].Sarea();
        storage += edgeArray[i].Storage();

        // edgeArray[i] бδȯ̤
        double wEvp = mEvp(edgeArray[i].Gx(), edgeArray[i].Gy());
        sumevp += edgeArray[i].Evalpha() * wEvp * 0.001 / 3600.0 * edgeArray[i].Cos() * edgeArray[i].Area(); // (m3/s)
      }
    }
  
  sp.Send_data(current_time, mQoutc);
  spSarea.Send_data(current_time, sarea/mSumArea);
  spStorage.Send_data(current_time, storage);
  spEvp.Send_data(current_time, sumevp/mSumArea*1000.*3600.); // (mm/h)

  /*
  // added for TRACER
  for (long i = 0; i < numberOfEdges; i++)
  {
    if (edgeArray[i].Atr() == 1) // ή-ήå
    {
      all_qr_file << current_time << " " << edgeArray[i].Num() << " " <<
      edgeArray[i].DischargeLowerEnd() << " " << wRain(edgeArray[i].Gx(), edgeArray[i].Gy()) << " " << edgeArray[i].Storage() <<endl;
    }
    else if (edgeArray[i].Atr() == 2) // ή-ƻå
    {
      //all_qr_file << current_time << " " << edgeArray[i].Num() <<" "<<
      edgeArray[i].DischargeLowerEnd() << " " << "0 0"<<endl;
    }
  }
  */

  return (Boolean)YES;
}

Boolean KsEdgeFc2dEvp::Calculate(void)
{
  // ߿嶯
  void* fdp; void* ldp;
  if (rp.Get_data_pack(fdp, current_time + time_step, ldp) == NO)
    return NO;
  
  time_t ft, lt;
  KhDMatrix fRain, lRain;
  ft = ((Data<KhDMatrix>*)fdp)->Data_time();
  lt = ((Data<KhDMatrix>*)ldp)->Data_time();
  fRain = ((Data<KhDMatrix>*)fdp)->Value();
  lRain = ((Data<KhDMatrix>*)ldp)->Value();
  
  /*
  time_t tt = current_time + time_step;
  
  if (tt == ft)
    {
      mRainn = fRain;
    }
  else if (tt == lt)
    {
      mRainn = lRain;
    }
  else
    {
      fRain *= (double)(lt-tt)/(double)(lt-ft);
      lRain *= (double)(tt-ft)/(double)(lt-ft);
      
      mRainn = fRain + lRain;
    }
  */

  // ѹ
  mRainn = lRain;
  
  // ñִ̻ȯ
  KhDMatrix fEvp, lEvp;
  if(evp.Get_data_pack(fdp, current_time + time_step, ldp) == NO)
    return NO;
  fEvp = ((Data<KhDMatrix>*)fdp)->Value();
  lEvp = ((Data<KhDMatrix>*)ldp)->Value();
  mEvpn = lEvp;

  // next step ξ֤η׻
  
  double all_rain=0.0;  // temporary defined n Nov. 5, 2002
  double all_area=0.0;  // temporary defined n Nov. 5, 2002
  
  mQoutn = 0.0;
  for (long i = 0; i < numberOfEdges; i++)
    {
      // edgeArray[i] бαͤ
      double wRainn = mRainn(edgeArray[i].Gx(), edgeArray[i].Gy());
      
      all_rain = all_rain + wRainn*edgeArray[i].Area();
      all_area = all_area + edgeArray[i].Area();
      
      // 		// for debugging
      // 		printf("edge %ld (%f)\n", edgeArray[i].Num(), wRainn);
      
      // 		// for debugging
      // 		printf("edge %ld [%ld, %ld]\n", edgeArray[i].Num(), 
      // 			edgeArray[i].Gx(), edgeArray[i].Gy());

      // edgeArray[i] бδȯ̤
      double wEvpn = mEvpn(edgeArray[i].Gx(), edgeArray[i].Gy());
      
      // ήз׻
      if (edgeArray[i].Calculate(wRainn, wEvpn) == (Boolean)NO)
      {
        Eprint(__FILE__, __LINE__);
        // 
        Oprint();
        exit(1);
      }
    
      // ⤷ edgeArray[i] ǲήåʤή̤
      // ­碌
      if (edgeArray[i].LowestEdge() == (Boolean)YES)
      {
        mQoutn += edgeArray[i].DischargeLowerEnd();
      }
    }
  
  // ˰°Ѥα̤׻
  double sarea = 0.0;
  double storage = 0.0;
  double sumevp = 0.0;
  for (long i = 0; i < numberOfEdges; i++)
    {
      if (edgeArray[i].Atr() == 1) // ή-ήå
    {
      sarea += edgeArray[i].Sarea();
      storage += edgeArray[i].Storage();
      sumevp += edgeArray[i].ActEvp() * 0.001 / 3600.0 * edgeArray[i].Cos() * edgeArray[i].Area(); // (m3/s);
    }
    }
  
  // ޤǤή
  mSumQout += (mQoutc + mQoutn) * (double)time_step * 0.5;
  
  // 	// Ǥα
  // 	mStorage = mSumRain - mSumQout;

/*
  //  (600 ˽Ϥ)
  double fmod600 = fmod((double)(current_time + time_step), 600);
  if(fmod600 == 0)
  {
    sp.Send_data(current_time + time_step, mQoutn);
    spSarea.Send_data(current_time + time_step, sarea/mSumArea);
    spStorage.Send_data(current_time + time_step, storage);
    spEvp.Send_data(current_time + time_step, sumevp/mSumArea*1000.*3600.); // (mm/h)
  }
*/
  sp.Send_data(current_time + time_step, mQoutn);
  spSarea.Send_data(current_time + time_step, sarea/mSumArea);
  spStorage.Send_data(current_time + time_step, storage);
  spEvp.Send_data(current_time + time_step, sumevp/mSumArea*1000.*3600.); // (mm/h)

  mQoutc = mQoutn;
  
  //printf("[%s %d] %ld : %f (%f)\n", object_name, object_number,
  //  current_time + time_step, mQoutn, all_rain/all_area);
  
  all_rain_file <<current_time + time_step<<" "<<all_rain/all_area<<endl;

  /*
  // added for TRACER
  for (long i = 0; i < numberOfEdges; i++)
  {
    if (edgeArray[i].Atr() == 1) // ή-ήå
    {
      all_qr_file << current_time + time_step << " " << edgeArray[i].Num() <<" "<<
      //edgeArray[i].DischargeLowerEnd() << " " << mRainn(edgeArray[i].Gx(), edgeArray[i].Gy()) <<endl; // check by T.Sayama on Oct. 10, 2006
      edgeArray[i].DischargeLowerEnd() << " " << mRainn(edgeArray[i].Gx(), edgeArray[i].Gy()) << " " << edgeArray[i].Storage() <<endl;
    }
    else if (edgeArray[i].Atr() == 2) // ή-ƻå
    {
      all_qr_file << current_time + time_step << " " << edgeArray[i].Num() <<" "<<
      //edgeArray[i].DischargeLowerEnd() << " " << "0"<<endl; // check by T.Sayama on Oct. 10, 2006
      edgeArray[i].DischargeLowerEnd() << " " << "0 0"<<endl;
    }
  }
  */
  
  return (Boolean)YES;
}
