/*;  newport.cc {\documentstyle[fleqn]{jsrc2latex}\font\tenrm=cmtt10} */

/*;  $$Revision$$ {\rhead{\sl newport.cc\quad\thepage}} */
/*;  $$Date$$  */
/*;  $$Source$$  */
/*;  $$RCShost$$  */

// @(#)

/*
{\ {\setlength{\parskip}{4pt}% latex-mode
...
}% end of latex-mode }
*/

#include <iostream>
#include "newport.h"
#include "portlist.h"

Port* new_port(char* classname, char* porttype)
{
  int gNumPorts = sizeof(gPortSet)/sizeof(Port*);
  for (int i = 0; i < gNumPorts; i++) {
    if ((strcmp(classname, gPortSet[i]->Class_name()) == 0) &&
      (strcmp(porttype, gPortSet[i]->Data_pack_type()) == 0)) {
      return gPortSet[i]->NewPort();
    }
  }
  return NULL;
}

/*; Local Variables: *** */
/*; tab-width: 4 *** */
/*; fill-column: 72 *** */
/*; End: *** */

/*; end of file */
